.include "send.asm"

.equ	STAFF_X00	=0b00000010
.equ	STAFF_X01	=0b00000100

.cseg 
Start0Interrupt:
		in	backupSREG,SREG	;store Status Register
		push T00
;********!start*******detect SOP*******
		push T01
		push T02

		ldi	T01,2
		ldi	T02,3
		push YL
		push YH
		;waiting for begin packet
CheckchangeMinus:
		sbis	inputport,DMinusChannel
		rjmp	CheckchangeMinus
CheckchangePlus:
		sbis	inputport,DPlusChannel
		rjmp	CheckchangePlus
DetectSOPEnd:
		sbis	inputport,DPlusChannel
		rjmp	Increment0		;D+ =0
Increment1:
		ldi	T02,3
		dec	T01
		ldi YL,low(USB_InPacket)
;		sbrc MainSlotsFlags,IN_PIPE_BCOPYED
;		ldi YL,low(USB_InPacket_B)
		nop
		nop
		breq	USBBeginPacket
		rjmp	DetectSOPEnd
Increment0:
		ldi	T01,2
		dec	T02

		ldi YH,high(USB_InPacket)
;		sbrc MainSlotsFlags,IN_PIPE_BCOPYED
;		ldi YH,high(USB_InPacket_B)
		nop
		nop
		brne	DetectSOPEnd
		rjmp	End0Interrupt


Stuff_0_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		nop
		nop
		rjmp Bit_1_Sign_1
Stuff_1_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		nop
		nop
		rjmp Bit_2_Sign_1
Stuff_2_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		nop
		nop
		rjmp Bit_3_Sign_1
Stuff_3_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		nop
		nop
		rjmp Bit_4_Sign_1
EndOfPacketShort:
		rjmp EndOfPacket
USBBeginPacket:
		ldi	T02,STAFF_X01
		ldi T01,STAFF_X00
Bit_0_Sign_0:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
LoopFromZero:
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_0_1
		ori T00,0x80
CHSign_0_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_0_0
Bit_1_Sign_0:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_1_1
		ori T00,0x80
CHSign_1_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_1_0
Bit_2_Sign_0:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_2_1
		ori T00,0x80
CHSign_2_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_2_0
Bit_3_Sign_0:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_3_1
		ori T00,0x80
CHSign_3_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_3_0
Bit_4_Sign_0:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_4_1
		ori T00,0x80
CHSign_4_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_4_0
Bit_5_Sign_0:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacketShort
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_5_1
		ori T00,0x80
CHSign_5_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_5_0
Bit_6_Sign_0:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket3Short
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_6_1
		ori T00,0x80
CHSign_6_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_6_0
Bit_7_Sign_0:
		in	BitInReg,InPutPort
		lsr T00
		sbrc BitInReg,DMinusChannel
		rjmp CHSign_7_1
		ori T00,0x80
CHSign_7_0:
		ldi T02,STAFF_X00
		lsl T01
		brcs Stuff_7_0
		st	Y+,T00
		in	BitInReg,InPutPort
		rjmp LoopFromZero
EndOfPacket3Short:
		rjmp EndOfPacket
Stuff_4_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		nop
		nop
		rjmp Bit_5_Sign_1
Stuff_5_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		nop
		nop
		rjmp Bit_6_Sign_1
Stuff_6_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		nop
		nop
		rjmp Bit_7_Sign_1
Stuff_7_0:
		ldi T01,STAFF_X00
		ldi T02,STAFF_X01
		nop
;		nop
		st	Y+,T00
		cpi YL,USB_InPacket+16+3
		BRGE ___End0Interrupt
		nop
		rjmp Bit_0_Sign_1
___End0Interrupt:	
		rjmp End0Interrupt

Stuff_0_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		nop
		nop
		rjmp Bit_1_Sign_0
Stuff_1_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		nop
		nop
		rjmp Bit_2_Sign_0
Stuff_2_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		nop
		nop
		rjmp Bit_3_Sign_0
Stuff_3_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		nop
		nop
		rjmp Bit_4_Sign_0
EndOfPacket2Short:
		rjmp EndOfPacket
Bit_0_Sign_1:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
LoopFromOne:
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_0_0
		ori T00,0x80
CHSign_0_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_0_1
Bit_1_Sign_1:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_1_0
		ori T00,0x80
CHSign_1_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_1_1
Bit_2_Sign_1:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_2_0
		ori T00,0x80
CHSign_2_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_2_1
Bit_3_Sign_1:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_3_0
		ori T00,0x80
CHSign_3_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_3_1
Bit_4_Sign_1:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket2Short
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_4_0
		ori T00,0x80
CHSign_4_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_4_1
Bit_5_Sign_1:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_5_0
		ori T00,0x80
CHSign_5_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_5_1
Bit_6_Sign_1:
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_6_0
		ori T00,0x80
CHSign_6_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_6_1
Bit_7_Sign_1:
		in	BitInReg,InPutPort
		lsr T00
		sbrs BitInReg,DMinusChannel
		rjmp CHSign_7_0
		ori T00,0x80
CHSign_7_1:
		ldi T01,STAFF_X00
		lsl T02
		brcs Stuff_7_1
		st	Y+,T00
		in	BitInReg,InPutPort
		rjmp LoopFromOne
Stuff_4_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket
		nop
		nop
		rjmp Bit_5_Sign_0
Stuff_5_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket
		nop
		nop
		rjmp Bit_6_Sign_0
Stuff_6_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		in	BitInReg,InPutPort
		andi BitInReg,(1<<DMinusChannel)|(1<<DPlusChannel)
		breq EndOfPacket
		nop
		nop
		rjmp Bit_7_Sign_0
Stuff_7_1:
		ldi T02,STAFF_X00
		ldi T01,STAFF_X01
		st	Y+,T00
		cpi YL,USB_InPacket+16+3
		BRGE __End0Interrupt
		nop
;		nop
		nop
		rjmp Bit_0_Sign_0
;__EndOfPacketShort:
;		rjmp EndOfPacketShort
__End0Interrupt:	
		rjmp End0Interrupt
EndOfPacket:
		;set our RW led
;		sbi OutPutPort,USB_DATA_RW

;		sbrc MainSlotsFlags,IN_PIPE_BCOPYED
;		rjmp BufferOccupy

		mov	 T00,YL
		subi T00,LOW(USB_InPacket)
		sts ReceiveDataSize,T00;stare received data size

		cpi	YL,USB_InPacket+3	;if at least 3 byte not received
		brcs	__End0Interrupt	;then finish

IsLongBuffer:
		lds	T00,USB_InPacket	;Packet identifier 'PID'

		cpi	T00,SOFPID
		breq __End0Interrupt

		lds	T01,USB_InPacket+1	;Try to receive address
		lsl T01
		lds	T02,USB_InPacket+2	;Try to receive Endpoint Number
FromOccupy:
		rol T02
		andi T02,0x0f;Hire we have endpoint number
		lsr	T01	;Hire we have Address number

;********Test packet For SETUP PID
		cpi T00,Low(SETUPPID)
		brne IsINPacket
;******Is our Address?******
		cpse 	T01,DeviceAddress
		rjmp	End0Interrupt
;***************************
		ldi		EngineState,SETUP_STATE; OK it's SETUP PACKET
;		sbr		ProcessingStatuses,1<<SETUP_IN_PROCESS
		rjmp	End0Interrupt
;********Test packet For IN PID
IsINPacket:
		cpi T00,Low(INPID)
		brne IsOUTPacket
;******Is our Address?******
		cpse 	T01,DeviceAddress
		rjmp	End0Interrupt

NoSetSetupSign:
		push	ZH
		push	ZL
		ldi		ZH,high(InEndpoints)
		ldi		ZL,low(InEndpoints)
		add		ZL,T02
		brcc	NoIncInEndpoints
		inc		ZH
NoIncInEndpoints:

		icall	;Goto IN endpoints vectors "endpoints.asm"
		pop		ZL
		pop		ZH
;***************************
		rjmp	EndInt0Handler		;a opakuj - cakaj na dalsiu odozvu z USB	;ENG;and repeat - wait for next response from USB
;********Test packet For OUT PID
IsOUTPacket:
		cpi T00,Low(OUTPID)
		brne IsDATAPacket
;******Is our Address?******
		cpse 	T01,DeviceAddress
		rjmp	End0Interrupt
;***************************
		ldi		EngineState,OUT_STATE; OK it's SETUP PACKET
		mov		OutEndpoint,T02
		rjmp	End0Interrupt
;********Test packet For DATA0/1 PID
IsDATAPacket:
		cpi T00,Low(DATA1PID)
		breq IsDATA0
;		rjmp IsDATA0
IsDATA0Packet:
		cpi T00,Low(DATA0PID)
		breq IsDATA0
		rjmp End0Interrupt			
;********Test ADDRESS for IN OUT SETUP PID
IsDATA0:
		cpi		EngineState,SETUP_STATE	;Device in SETUP state
		breq	ReceiveOutData
		cpi		EngineState,OUT_STATE	;Device in OUT state
		breq	ReceiveOutData
		ldi		EngineState,BASE_STATE	;It is not our packet, - device in setup state
		rjmp 	End0Interrupt			
;********************************************************
ReceiveOutData:
;		rcall	SendACK			;akceptovanie Setup Data paketu	;ENG;accept Setup Data packet
		push	ZH
		push	ZL
		ldi		ZH,high(OutEndpoints)
		ldi		ZL,low(OutEndpoints)
		add		ZL,OutEndpoint
		brcc	NoIncOutEndpoints
		inc		ZH

NoIncOutEndpoints:
		icall	;Goto OUT endpoints vectors "endpoints.asm"
		pop		ZL
		pop		ZH
		rjmp	EndInt0Handler
;********************************************************
EndInt0Handler:
;		pop	ACC
;		pop	XL
;		pop	T03
;		pop	T02			;zazalohuj dalsie registre a pokracuj
End0Interrupt:
		pop YH
		pop YL
;End0Interrupt:
		pop T02
		pop T01
_End0Interrupt:
;		cbi OutPutPort,USB_DATA_RW
		pop T00
		out	SREG,backupSREG
		ldi	BitInReg,1<<INTF1	;zero interruptu flag INTF0
		out	GIFR,BitInReg
		reti				;End Interrupt, return from this.
/*
BufferOccupy:
		cpi	YL,USB_InPacket_B+3	;if at least 3 byte not received
		brcs	End0Interrupt	;then finish

;		cpi	YL,USB_InPacket+3	;if at least 3 byte not received
;		brcs	__End0Interrupt	;then finish

		lds	T00,USB_InPacket_B	;Packet identifier 'PID'

		lds	T01,USB_InPacket_B+1	;Try to receive address
		lsl T01
		lds	T02,USB_InPacket_B+2	;Try to receive Endpoint Number
		rjmp	FromOccupy
		*/
/*
ProcessHanshake:
		cpi	ProcessingStatuses,DO_WAIT_FOR_ASK
		breq ProcessACK
		rjmp End0Interrupt
ProcessACK:
		lds	T00,USB_InPacket
		cpi T00,ACKPID
		breq ACK
		cpi T00,NAKPID
		brne ACK
NAK:
		ldi		ProcessingStatuses,DO_PS_DATA_READY
		rjmp End0Interrupt
ACK:
		ldi	ProcessingStatuses,DO_PS_DATA_READER
		rjmp End0Interrupt
*/
;EndInterrupt:
;		clr	ProcessingStatuses
;		rjmp End0Interrupt
