.equ	UP_1		=PC0;
.equ	DOWN_1		=PC2;
.equ	LEFT_1		=PD7;
.equ	RIGHT_1		=PC4;
.equ	BUT_START_1	=PC1;
.equ	BUT_MODE_1	=RIGHT_1;
.equ	BUT_A_1		=PC5;
.equ	BUT_C_1		=BUT_START_1;
.equ	BUT_B_1		=BUT_A_1;
.equ	BUT_X_1		=LEFT_1;
.equ	BUT_Y_1		=DOWN_1;
.equ	BUT_Z_1		=UP_1;
.equ	SELECT_1	=PC3;

.equ	UP_2		=PD6;
.equ	DOWN_2		=PD5;
.equ	LEFT_2		=PD4;
.equ	RIGHT_2		=PE1;
.equ	BUT_START_2	=PC6;
.equ	BUT_MODE_2	=RIGHT_2;
.equ	BUT_A_2		=PE0;
.equ	BUT_C_2		=BUT_START_2;
.equ	BUT_B_2		=BUT_A_2;
.equ	BUT_X_2		=LEFT_2;
.equ	BUT_Y_2		=DOWN_2;
.equ	BUT_Z_2		=UP_2;
.equ	SELECT_2	=PC7;

read_sega_1:
;//*****************************************************************
;//** report 1 proc
;//*****************************************************************
;.equ	UP_1		=PC0;
;.equ	DOWN_1		=PC2;
;.equ	LEFT_1		=PD7;
;.equ	RIGHT_1		=PC4;
;.equ	BUT_START_1	=PC1;
;.equ	BUT_A_1		=PC5;
;.equ	SELECT_1	=PC3;

		;setup ports
		sbi		DDRC,SELECT_1
		cbi		DDRC,UP_1
		cbi		DDRC,DOWN_1
		cbi		DDRD,LEFT_1
		cbi		DDRC,RIGHT_1
		cbi		DDRC,BUT_START_1
		cbi		DDRC,BUT_A_1

		;SELECT 0
		cbi		PORTC,SELECT_1
		rcall	SegaWait

		;clear temporary buffers
		clr		T01
		clr		T02
		clr		T03

		//Read A,Start
		sbis	PINC,BUT_A_1
		sbr		T01,0b00000001

		sbis	PINC,BUT_START_1
		sbr		T01,0b00000010

		//SELECT 1
		sbi		PORTC,SELECT_1
		rcall	SegaWait

		//UP,DOWN
		sbis	PINC,UP_1
		ldi		T03,0x81

		sbis	PINC,DOWN_1
		ldi		T03,0x7F
		//LEFT, RIGHT
		sbis	PIND,LEFT_1
		ldi		T02,0x81

		sbis	PINC,RIGHT_1
		ldi		T02,0x7F

		//B, C 
		sbis	PINC,BUT_B_1
		sbr		T01,0b00001000


		sbis	PINC,BUT_C_1
		sbr		T01,0b00000100


		//Store X,Y
		sts		SEGA1TMP,T02
		sts		SEGA1TMP+1,T03
		//6 BUTTONS
		cbi		PORTC,SELECT_1
		rcall	SegaWait
		sbi		PORTC,SELECT_1
		rcall	SegaWait
		cbi		PORTC,SELECT_1
		rcall	SegaWait
		sbi		PORTC,SELECT_1
		rcall	SegaWait

		sbis	PIND,BUT_X_1
		sbr		T01,0b00010000
		sbis	PINC,BUT_Y_1
		sbr		T01,0b00100000
		sbis	PINC,BUT_Z_1
		sbr		T01,0b01000000
		sbis	PINC,BUT_MODE_1
		sbr		T01,0b10000000

		sts		SEGA1TMP+2,T01

		//we read data? and must remove read flug
		andi	additional_flgs,~(1<<SEGAJOY1_NEEDREAD)

		//X
		lds		T00,SEGA1TMP
		lds		T02,SEGA1BULK+2

		cpse	T00,T02
		rjmp	UpdateSegaData1

		//Y
		lds		T00,SEGA1TMP+1
		lds		T02,SEGA1BULK+3

		cpse	T00,T02
		rjmp	UpdateSegaData1

		//Buttons
		lds		T00,SEGA1TMP+2
		lds		T02,SEGA1BULK+4

		cpse	T00,T02
		rjmp	UpdateSegaData1
		ret

UpdateSegaData1:
		push	ByteCount
		push	YH
		push	YL

		ldi	ByteCount,4+2
		ldi	YL,Low(SEGA1BULK)
		ldi	YH,High(SEGA1BULK)

		//Store X POS
		lds		T00,SEGA1TMP
		std		Y+2,T00
		//Store Y POS
		lds		T00,SEGA1TMP+1
		std		Y+3,T00
		//Store BUTTONS
		lds		T00,SEGA1TMP+2
		std		Y+4,T00
		//Store report ID
		ldi		T00,0x01
		std		Y+1,T00
			
		rcall CalcCRC16

		pop		YL
		pop		YH
		pop		ByteCount
	;set send flag
		ori	additional_flgs,(1<<SEGAJOY1_NEEDSEND)
		ret

read_sega_2:
;//*****************************************************************
;//** report 1 proc
;//*****************************************************************
		;setup ports
		sbi		DDRC,SELECT_2
		cbi		DDRD,UP_2
		cbi		DDRD,DOWN_2
		cbi		DDRD,LEFT_2
		cbi		DDRE,RIGHT_2
		cbi		DDRC,BUT_START_2
		cbi		DDRE,BUT_A_2

		;SELECT 0
		cbi		PORTC,SELECT_2
		rcall	SegaWait

		;clear temporary buffers
		clr		T01
		clr		T02
		clr		T03

		//Read A,Start
		sbis	PINE,BUT_A_2
		sbr		T01,0b00000001

		sbis	PINC,BUT_START_2
		sbr		T01,0b00000010

		//SELECT 1
		sbi		PORTC,SELECT_2
		rcall	SegaWait

		//UP,DOWN
		sbis	PIND,UP_2
		ldi		T03,0x81

		sbis	PIND,DOWN_2
		ldi		T03,0x7F
		//LEFT, RIGHT
		sbis	PIND,LEFT_2
		ldi		T02,0x81

		sbis	PINE,RIGHT_2
		ldi		T02,0x7F

		//B, C 
		sbis	PINE,BUT_B_2
		sbr		T01,0b00001000


		sbis	PINC,BUT_C_2
		sbr		T01,0b00000100


		//Store X,Y
		sts		SEGA2TMP,T02
		sts		SEGA2TMP+1,T03
		//6 BUTTONS
		cbi		PORTC,SELECT_2
		rcall	SegaWait
		sbi		PORTC,SELECT_2
		rcall	SegaWait
		cbi		PORTC,SELECT_2
		rcall	SegaWait
		sbi		PORTC,SELECT_2
		rcall	SegaWait

		sbis	PIND,BUT_X_2
		sbr		T01,0b00010000
		sbis	PIND,BUT_Y_2
		sbr		T01,0b00100000
		sbis	PIND,BUT_Z_2
		sbr		T01,0b01000000
		sbis	PINE,BUT_MODE_2
		sbr		T01,0b10000000

		sts		SEGA2TMP+2,T01

		//we read data? and must remove read flug
		andi	additional_flgs,~(1<<SEGAJOY2_NEEDREAD)

		//X
		lds		T00,SEGA2TMP
		lds		T02,SEGA2BULK+2

		cpse	T00,T02
		rjmp	UpdateSegaData2

		//Y
		lds		T00,SEGA2TMP+1
		lds		T02,SEGA2BULK+3

		cpse	T00,T02
		rjmp	UpdateSegaData2

		//Buttons
		lds		T00,SEGA2TMP+2
		lds		T02,SEGA2BULK+4

		cpse	T00,T02
		rjmp	UpdateSegaData2
		ret

UpdateSegaData2:
		push	ByteCount
		push	YH
		push	YL

		ldi	ByteCount,4+2
		ldi	YL,Low(SEGA2BULK)
		ldi	YH,High(SEGA2BULK)

		//Store X POS
		lds		T00,SEGA2TMP
		std		Y+2,T00
		//Store Y POS
		lds		T00,SEGA2TMP+1
		std		Y+3,T00
		//Store BUTTONS
		lds		T00,SEGA2TMP+2
		std		Y+4,T00
		//Store report ID
		ldi		T00,0x01
		std		Y+1,T00
			
		rcall CalcCRC16

		pop		YL
		pop		YH
		pop		ByteCount
	;set send flag
		ori	additional_flgs,(1<<SEGAJOY2_NEEDSEND)
		ret

SegaWait:
		ldi		T00,0x0A
SegaWaitLoop:
		nop
		nop
		dec		T00
		brne	SegaWaitLoop
		ret		
